/**
 ** KSplash (Maclike)
 ** Copyright (c) 2001, Flaming Sword Productions
 ** All Rights Reserved
 **
 ** $Id: ThemeEngine.h,v 1.3 2002/06/11 21:11:04 brian Exp $
 **/
#ifndef		__OBJTHEMEENGINE_H__
#define		__OBJTHEMEENGINE_H__
#include	<qvbox.h>
#include	<qpixmap.h>
#include	<qstringlist.h>
#include	<qwidget.h>
#include	"../objkstheme.h"

/**
 ** class ThemeEngineConfig: This class is a base for the ThemeEngine's 
 ** configuration widget.
 **/
class		ThemeEngineConfig: public QVBox {
Q_OBJECT
public:

		ThemeEngineConfig( QWidget *p, KConfig *c )
		:QVBox( p ), gConfig( c ) {}

	inline KConfig*	config() { return( gConfig ); }

public slots:
virtual	void		load() {}
virtual	void		save() {}

protected:
	KConfig		*gConfig;
};

/**
 ** class ThemeEngine: This provides a common frontend to the various
 ** theme engines available to the end-user.  This will need to be
 ** overridden by other classes in order to provide actual functionality.
 **/
class		ThemeEngine: public QVBox {
Q_OBJECT
public:
		ThemeEngine( QWidget *, ObjKsTheme * );

inline virtual const ThemeEngineConfig *config( QWidget *, KConfig * ) { return 0L; };

public slots:
virtual void		slotUpdateProgress( int ) {};
virtual void		slotUpdateSteps( int ) {};
virtual void		slotSetText( const QString& ) {};
virtual void		slotSetPixmap( const QString& ) {}; // use DesktopIcon() to load this.

protected:
	QWidget		*gParent;
	ObjKsTheme	*gTheme;
};

/**
 ** KSplash/ML ThemeEngine API.  The following functions should be exported
 ** via extern "C" in your ThemeEngine's linked code.  Please see all ThemeEngines
 ** for examples of usage.
 **/
//extern "C" {
//QStringList		KsThemeSupports();
//void			*KsThemeInit( QWidget *, ObjKsTheme * );
//ThemeEngineConfig	*KsThemeConfig( QWidget *, KConfig * );
//};

/**
 ** Because I've changed this class name, I'd best provide some sort of fallback to the
 ** old class name, in the event that somebody hasn't updated their ThemeEngine codebase 
 ** yet.  Since there are around 3 people using this codebase, I don't suspect that this
 ** is necessary, but more backwards-compatibility is _always_ better than less, right?
 **/
typedef class ThemeEngine ObjThemeEngine;



#endif
