/**
 ** KSplash (Maclike)
 ** Copyright (c) 2001, Flaming Sword Productions
 ** All Rights Reserved
 **
 ** $Id: objkstheme.h,v 1.16 2002/06/03 14:32:18 brian Exp $
 **/
#ifndef		__OBJKSTHEME_H__
#define		__OBJKSTHEME_H__
#include	<kdebug.h>
#include	<kcmdlineargs.h>
#include	<kconfig.h>
#include	<qcolor.h>
#include	<qfont.h>
#include	<qstring.h>

/**
 ** ObjKsTheme: A Theme is read in from the file 
 ** <KDEDIR>/share/apps/ksplashml/Themes/<theme>/theme.rc
 ** This controls the behavior, graphics, and appearance
 ** of KSplash/ML completely, and offers a friendlier way
 ** of installing custom splash screens.
 **/
class		ObjKsTheme {
public:
		ObjKsTheme( const QString& );

	void		loadCmdLineArgs( KCmdLineArgs * );

inline	QString		theme() { return( gActiveTheme ); }
inline	QString		themeEngine() { return( oThemeEngine ); }
inline	KConfig		*themeConfig() { return( gThemeConfig ); }
inline	QString		themeDir() { return( oThemeDir ); }

inline	bool		loColor() { return( oLoColor ); }
inline	bool		testing() { return( oTesting ); }
inline	bool		managedMode() { return( oManagedMode ); }

inline	QString		icon( int i ) { return (_icons[i-1].isNull()?QString(""):_icons[i-1]); }
inline	QString		text( int i ) { return (_text[i-1].isNull()?QString(""):_text[i-1]); }

protected:
	bool		loadThemeRc( const QString& );
	bool		loadLocalConfig( const QString& );
	bool		loadKConfig( KConfig *, const QString& );

private:
	QString		gActiveTheme, oThemeDir;
	KConfig		*gThemeConfig;

	bool		oLoColor, oTesting, oManagedMode;
	QString		oThemeEngine;

	QStringList	_icons, _text;
};

#endif
